<?php

// -------------------------------------------------------------------------- \\
// Uploaded files manager - provides some uploads control structures          \\
// -------------------------------------------------------------------------- \\

// Simple InUSE Check
if ( !defined('QF_STARTED') )
        die('Hacking attempt');

if (defined('QF_FILER_LOADED'))
    die('Scripting error');

define('QF_FILER_LOADED', true);

define('QF_FILES_UPLOADS_DIR' ,    QF_DATA_ROOT.'uploads/');
define('QF_FILES_THUMBS_DIR'  ,    QF_DATA_ROOT.'thb_n_prvw/');
define('QF_FILES_PREVIEWS_DIR',    QF_DATA_ROOT.'thb_n_prvw/');

define('QF_FOLDER_TREE_CACHENAME', 'FOLDERS_TREE');

class QF2_Files
{

    var $infos = Array();
    var $f_tree = Array();
    var $fconts = Array();

    function QF2_Files()
    {

    }

    function Get_FolderInfo($fold_id)
    {
        global $QF;

        $fold_id = (int) $fold_id;

        if (!isset($this->f_tree[$fold_id]))
            return false;

        $data =&$this->f_tree[$fold_id];

        if (!isset($data['contents']));

        return $data;
    }

    function Get_FolderConts($fold_id, $acc_lvl = false)
    {
        global $QF;

        $fold_id = (int) $fold_id;

        if (!isset($this->f_tree[$fold_id]))
            return false;

        if (!isset($this->fconts[$fold_id]));
        {
            $where = Array('folder' => $fold_id, 'is_temp' => 0);
            if (is_int($acc_lvl))
                $where['r_level'] = '<= '.$acc_lvl;
            $conts = $QF->DBase->Do_Select_All('files', 'id', $where, 'ORDER BY time DESC', QF_SQL_USEFUNCS);
            $this->fconts[$fold_id] = (is_array($conts)) ? $conts : Array();
        }

        return $this->fconts[$fold_id];
    }

    function Get_FoldersTree()
    {
        return $this->f_tree;
    }

    function Get_TempFiles($uid = false, $mime_cls = false)
    {
        global $QF;

        $flags = false;
        $cond = Array('is_temp' => 1);
        if (is_int($uid))
            $cond['author_id'] = $uid;
        if (is_string($mime_cls) && $mime_cls)
        {
            $cond['mime'] = 'LIKE '.preg_replace('#\W#', '', $mime_cls).'/%';
            $flags |= QF_SQL_USEFUNCS;
        }

        $conts = $QF->DBase->Do_Select_All('files', 'id', $cond, 'ORDER BY time', $flags);


        return $conts;
    }

    function Get_FileInfo($fid)
    {
        global $QF;

        if (!preg_match('#^[0-9A-z]{8}$#D', $fid)) // incorrect file ID
            return false;

        $fid = strtolower($fid);

        if (isset($this->infos[$fid]))
            return $this->infos[$fid];

        if ($this->Load_FileInfos($fid))
            return $this->infos[$fid];

        return false;
    }

    function _Start()
    {
        global $QF;

        if (list($f_tree, $f_conts) = $QF->Cache->Get(QF_FOLDER_TREE_CACHENAME))
        {
            $this->f_tree = $f_tree;
        }
        else
            $this->_Analyze_Folders();
    }

    function _Analyze_Folders()
    {
        global $QF;

        $f_tree = Array(0 => Array('id' => 0, 'parent' => null, 'name' => '[root folder]', 'type' => 0,
                           'r_level' => 0, 'w_level' => 7, 'acc_gr' => 0, 'mtime' => 0, 'files' => 0,
                           'size' => 0, 'is_sys' => 1));
        $f_conts = Array();

        if ($folders = $QF->DBase->Do_Select_All('file_folders', '*'))
        {
            $fls_pars = Array();

        	foreach ($folders as $folder) // temporary data dividing
        	{
                $fls_pars[$folder['id']] = $folder['parent'];
                $fls_tmps[$folder['id']] = $folder;
        	}
        	unset ($folders);

            $cur_fl = 0;
            $cstack = Array();
            while (count($fls_pars)) // folder tree resorting
            {
                if ($childs = array_keys($fls_pars, $cur_fl))
                {
                	array_push($cstack, $cur_fl);
                	$cur_fl = $childs[0];
                	$child = $fls_tmps[$folder['id']];
                	$child['t_level'] = count($cstack); // level
                	$f_tree[$cur_fl] = $child;
                	unset($fls_pars[$cur_fl]);
                }
                elseif ($cur_fl = array_pop($cstack))
                {
                	// do nothing
                }
                else // this will open looped parentship
                {
                    reset($fls_pars);
                    $key = key($fls_pars);
                    $fls_tmps[$key]['parent'] = 0; // we'll link one folder to root
                    $fls_pars[$key] = 0;
                    $QF->DBase->Do_Update('file_folders', Array('parent' => 0), Array('id' => $key) );
                }
            }

            unset ($fls_pars, $fls_tmps);


        }

        $QF->Cache->Set(QF_FOLDER_TREE_CACHENAME, Array($f_tree, $f_conts));
        $this->f_tree = $f_tree;
    }

    function Load_FileInfos($fids)
    {
        global $QF;

        if (!$fids)
            return false;

        if (!is_array($fids))
            $fids = explode('|', $fids);

        if ($datas = $QF->DBase->Do_Select_All('files', '*', Array('id' => $fids)))
        {
            foreach ($datas as $data)
            {
                $fid = $data['id'];
                $file_link = QF_FILES_UPLOADS_DIR.$data['file_id'].'.qff';
                if (file_exists($file_link))
                {
                    $data['file_link'] = $file_link;
                    $fsize = filesize($file_link);
                    if ($fsize != $data['file_size'])
                    {
                        $QF->DBase->Do_Update('files', Array('file_size' => $fsize), Array('id' => $fid));
                        $data['file_size'] = $fsize;
                    }
                }
                else
                    $data['file_link'] = false;

                if ($data['has_pics'])
                {
                    $prv_link = QF_FILES_PREVIEWS_DIR.$data['file_id'].'.qfp';
                    $thb_link = QF_FILES_THUMBS_DIR.$data['file_id'].'.qft';
                    $data['prv_link'] =& $prv_link;
                    $data['thb_link'] =& $thb_link;


                    if (!file_exists($thb_link))
                    {
                        $thb_link = false;
                        $prv_link = false;
                        $data['has_pics'] = 0;
                        $QF->DBase->Do_Update('files', Array('has_pics' => 0), Array('id' => $fid));
                    }
                    if (!file_exists($prv_link))
                        $prv_link = false;
                }

                if (!$data['mime'])
                {
                    $fext = pathinfo($data['filename'], PATHINFO_EXTENSION);
                    if ($ftype = qf_file_mime($data['file_link'], $fext))
                        $data['mime'] = $ftype;
                    else
                        $data['mime'] = 'application/octet-stream';
                }

                $this->infos[$fid] = $data;
            }

            return true;
        }
        else
            return false;
    }

    function Modif_File($fid, $params = Array(), $new_file = false)
    {
        global $QF;

        if (!preg_match('#^[0-9A-z]{8}$#D', $fid)) // incorrect file ID
            return false;

        $fid = strtolower($fid);

        if (!isset($this->infos[$fid]))
            if (!$this->Load_FileInfos($fid))
                return false;

        if (!is_array($params))
            $params = Array();

        $finfo =& $this->infos[$fid];

        $can_modif = Array(
            'folder', 'is_temp', 'author', 'author_id', 'author_ip',
            'time', 'r_level', 'caption', 'filename',
            );

        $upd_info = Array();
        foreach ($can_modif as $par)
        {
            if (isset($params[$par]) && !(empty($params[$par]) && !is_int($params[$par])))
            {
                settype($params[$par], gettype($finfo[$par]));
                $upd_info[$par] = $params[$par];
            }
        }

        $file_link = false;
        if ($new_file && file_exists($new_file))
        {
            $mime = qf_file_mime($new_file, pathinfo($upd_info['filename'], PATHINFO_EXTENSION));
            $new_fid = md5(uniqid($new_file));
            $file_link = QF_FILES_UPLOADS_DIR.$new_fid.'.qff';
            if (copy($new_file, $file_link))
            {
                chmod($file_link, 0600);

                $upd_info += Array(
                    'file_id' => $new_fid, 'file_md5' => (string) qf_md5_file($new_file), 'file_gzip' => 0,
                    'file_size' => filesize($new_file), 'mime' => $mime, 'is_arch' => ($mime == 'application/x-tar') ? 1 : 0,
                    );
            }

        }

        if ($QF->DBase->Do_Update('files', $upd_info, Array('id' => $fid)) !== false)
        {
            $o_folder = $finfo['folder'];
            $finfo = $upd_info + $finfo;
            $fold_id = $finfo['folder'];
            unset($this->fconts[$fold_id], $this->fconts[$o_folder]);
            if ($file_link)
            {
                if (($o_link = $this->infos[$fid]['file_link']) && file_exists($o_link))
                    unlink ($o_link);
                if (($o_link = $this->infos[$fid]['prv_link']) && file_exists($o_link))
                    unlink ($o_link);
                if (($o_link = $this->infos[$fid]['thb_link']) && file_exists($o_link))
                    unlink ($o_link);

                $finfo['file_link'] = $file_link;
                $this->Regen_Pics($fid);
            }
            $QF->Cache->Drop(QF_FOLDER_TREE_CACHENAME);
            return true;
        }

        return false;
    }

    function Create_File($filename, $params = Array())
    {
        global $QF;

        if (!file_exists($filename))
            return false;
        $fid = md5(uniqid($filename));
        $data = Array(
            'id' => qf_short_uid($filename),
            'folder' => 0, 'is_temp' => 1,
            'author' => $QF->User->uname, 'author_id' => $QF->User->UID, 'author_ip' => $QF->HTTP->IP_int,
            'time' => $QF->Timer->time, 'r_level' => 0, 'caption' => $filename, 'filename' => $filename,
            );

        if (is_array($params))
          foreach ($params as $par=>$val)
            if (isset($data[$par]) && !empty($val))
            {
                settype($val, gettype($data[$par]));
                $data[$par] = $val;
            }

        $mime = qf_file_mime($filename, pathinfo($data['filename'], PATHINFO_EXTENSION));
        $data += Array(
            'file_id' => $fid, 'file_md5' => (string) qf_md5_file($filename), 'file_gzip' => 0,
            'file_size' => filesize($filename), 'mime' => $mime, 'is_arch' => ($mime == 'application/x-tar') ? 1 : 0,
            );

        $file_link = QF_FILES_UPLOADS_DIR.$data['file_id'].'.qff';
        if (copy($filename, $file_link))
        {
            chmod($file_link, 0600);

            $i = 10;
            $done = false;
            while (!$done && $i>0)
            {
                $data['id'] = qf_short_uid($filename);
                $done = $QF->DBase->Do_Insert('files', $data);
                $i--;
            }

            if (!$done)
            {
                unlink($file_link);
                trigger_error('FOX_FILES: Can\'t insert new file info into DB', E_USER_WARNING);
                return false;
            }

            $this->Regen_Pics($data['id']);
            return $data['id'];
        }
        else
            trigger_error('FOX_FILES: Can\'t copy file into a storage folder', E_USER_WARNING);

        return false;
    }

    function Regen_Pics($fid)
    {
        global $QF;

        if (!preg_match('#^[0-9A-z]{8}$#D', $fid)) // incorrect file ID
            return false;

        $fid = strtolower($fid);

        if (!isset($this->infos[$fid]))
            if (!$this->Load_FileInfos($fid))
                return false;


        $finfo =& $this->infos[$fid];

        if (strstr($finfo['mime'], 'image/') && $QF->Run_Module('Imager') && ($iinfo = $QF->Imager->Check_IType($finfo['file_link'])))
        {
            //$QF->Imager->Configure(false, true);
            list($th_w, $th_h) = explode('|', $QF->Config->Get('thb_size', 'files_cfg', '64|64'));
            list($prv_w, $prv_h) = explode('|', $QF->Config->Get('prv_size', 'files_cfg', '256|256'));

            $conf = Array(
                'width' => $prv_w,
                'height' => $prv_h,
                'rsize_mode' => QF_IMAGER_RSIZE_FIT,
            );

            $conf_th = Array(
                'width' => $th_w,
                'height' => $th_h,
                'rsize_mode' => QF_IMAGER_RSIZE_FIT,
            );

            $out_type = $iinfo[2];

            $prv_file = QF_FILES_PREVIEWS_DIR.$finfo['file_id'].'.qfp';
            $thb_file = QF_FILES_THUMBS_DIR.$finfo['file_id'].'.qft';
            if ($QF->Imager->Parse_Image($finfo['file_link'], $prv_file, $out_type, QF_IMAGER_DO_RESIZE, $conf)
                && $QF->Imager->Parse_Image($finfo['file_link'], $thb_file, $out_type, QF_IMAGER_DO_RESIZE, $conf_th))
            {
                $data = Array(
                    'has_pics' => 1,
                    'pics_mime' => $iinfo['mime'],
                    'aspect_ratio' => $iinfo[0]/$iinfo[1],
                    );

                if ($QF->DBase->Do_Update('files', $data, Array('id' => $fid)))
                {
                    unset($this->infos[$fid]);
                    return true;
                }
            }
        }

        return false;
    }

    function Drop_File($fid)
    {
        global $QF;

        if (!preg_match('#^[0-9A-z]{8}$#D', $fid)) // incorrect file ID
            return false;

        $fid = strtolower($fid);

        if (!isset($this->infos[$fid]))
            if (!$this->Load_FileInfos($fid))
                return false;

        if ($QF->DBase->Do_Delete('files', Array('id' => $fid)))
        {
            $o_folder = $this->infos[$fid]['folder'];
            unset($this->fconts[$o_folder]);
            if (($o_link = $this->infos[$fid]['file_link']) && file_exists($o_link))
                unlink ($o_link);
            if (($o_link = $this->infos[$fid]['prv_link']) && file_exists($o_link))
                unlink ($o_link);
            if (($o_link = $this->infos[$fid]['thb_link']) && file_exists($o_link))
                unlink ($o_link);

            unset($this->infos[$fid]);
            $QF->Cache->Drop(QF_FOLDER_TREE_CACHENAME);
            return true;
        }

        return false;
    }

    function Move_File($fid, $fold_id)
    {
        global $QF;

        if (!preg_match('#^[0-9A-z]{8}$#D', $fid)) // incorrect file ID
            return false;

        $fold_id = (int) $fold_id;

        if (!isset($this->f_tree[$fold_id]))
            return false;

        $fid = strtolower($fid);

        if (!isset($this->infos[$fid]))
            if (!$this->Load_FileInfos($fid))
                return false;

        if ($QF->DBase->Do_Update('files', Array('is_temp' => 0, 'folder' => $fold_id), Array('id' => $fid)))
        {
            $this->infos[$fid]['is_temp'] = 0;
            $o_folder = $this->infos[$fid]['folder'];
            $this->infos[$fid]['folder'] = $fold_id;
            unset($this->fconts[$fold_id], $this->fconts[$o_folder]);
            $QF->Cache->Drop(QF_FOLDER_TREE_CACHENAME);
            return true;
        }

        return false;
    }

    function Incrase_Stats($fid)
    {
        global $QF, $FOX;

        if (!preg_match('#^[0-9A-z]{8}$#D', $fid)) // incorrect file ID
            return false;

        if ($QF->DBase->DO_Update('files', Array('dloads' => '++ 1'), Array('id' => $fid), QF_SQL_USEFUNCS))
            return true;
        else
            return false;
    }

    function Check_DCode($fid, $dcode)
    {
        global $QF;

        if (!preg_match('#^[0-9A-z]{8}$#D', $fid)) // incorrect file ID
            return false;

        $selector = Array(
            'dl_id'     => $dcode,
            'file_id'   => $fid,
            'client_ip' => $QF->HTTP->IP_int,
            );

        if (($act_till = $QF->DBase->Do_Select('file_dloads', 'active_till', $selector)) && ($act_till >= $QF->Timer->time))
            return true;
        else
            return false;
    }

    function Gen_DCode($fid)
    {
        global $QF;

        if (!preg_match('#^[0-9A-z]{8}$#D', $fid)) // incorrect file ID
            return false;

        $fid = strtolower($fid);

        if (!isset($this->infos[$fid]) && !$this->Get_FileInfo($fid))
            return false;

        $info = $this->infos[$fid];

        $QF->Session->Open_Session();

        if ($QF->User->is_spider || !$QF->User->CheckAccess($info['r_level']))
            return false;

        // we'll try to find needed dload by session
        $selector = Array(
            'sid'       => $QF->Session->SID,
            'file_id'   => $info['id'],
            'client_ip' => $QF->HTTP->IP_int,
            );
        if ($QF->Session->Get_Status(QF_SESSION_LOADED) && ($ddata = $QF->DBase->Do_Select('file_dloads', Array('dl_id', 'active_till'), $selector)) && ($ddata['active_till'] >= $QF->Timer->time))
        {
            $dcode = $ddata['dl_id'];
            return $dcode;
        }
        else
        {
            $dcode = md5(uniqid($QF->HTTP->Cl_ID));
            $selector['active_till'] = $QF->Timer->time + 3*QF_KERNEL_SESSION_LIFETIME;
            $selector['dl_id'] = $dcode;
            $selector['sid']   = $QF->Session->SID;
            if ($QF->DBase->Do_Insert('file_dloads', $selector, true))
            {
                $QF->DBase->Do_Delete('file_dloads', Array('active_till' => '< '.$QF->Timer->time), QF_SQL_USEFUNCS);
                $this->Incrase_Stats($info['id']); // update dloads counter
                return $dcode;
            }
            else
                trigger_error('FOX_FILES: Can\'t insert new dload into DB', E_USER_ERROR);
        }

        return false;

    }

}

?>
